Package org.lwjgl.opengl

# Class GL31

java.lang.Object
org.lwjgl.opengl.GL31

public final class GL31 extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH`
Accepted by the <pname> parameter of GetProgramiv:
`static final int`
`GL_ACTIVE_UNIFORM_BLOCKS`
Accepted by the <pname> parameter of GetProgramiv:
`static final int`
`GL_COPY_READ_BUFFER`
`static final int`
`GL_COPY_READ_BUFFER_BINDING`
`static final int`
`GL_COPY_WRITE_BUFFER`
`static final int`
`GL_COPY_WRITE_BUFFER_BINDING`
`static final int`
`GL_INVALID_INDEX`
Returned by GetActiveUniformsiv and GetUniformBlockIndex
`static final int`
`GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_COMBINED_UNIFORM_BLOCKS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_FRAGMENT_UNIFORM_BLOCKS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_GEOMETRY_UNIFORM_BLOCKS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_RECTANGLE_TEXTURE_SIZE`
Accepted by the <pname> parameter of GetBooleanv, GetDoublev, GetIntegerv and GetFloatv:
`static final int`
`GL_MAX_TEXTURE_BUFFER_SIZE`
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:
`static final int`
`GL_MAX_UNIFORM_BLOCK_SIZE`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_UNIFORM_BUFFER_BINDINGS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_MAX_VERTEX_UNIFORM_BLOCKS`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_PRIMITIVE_RESTART`
Accepted by the <cap> parameter of IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_PRIMITIVE_RESTART_INDEX`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_PROXY_TEXTURE_RECTANGLE`
Accepted by the <target> parameter of GetTexLevelParameteriv, GetTexLevelParameterfv, GetTexParameteriv and TexImage2D:
`static final int`
`GL_R16_SNORM`
`static final int`
`GL_R8_SNORM`
`static final int`
`GL_RED_SNORM`
`static final int`
`GL_RG_SNORM`
`static final int`
`GL_RG16_SNORM`
`static final int`
`GL_RG8_SNORM`
`static final int`
`GL_RGB_SNORM`
`static final int`
`GL_RGB16_SNORM`
`static final int`
`GL_RGB8_SNORM`
`static final int`
`GL_RGBA_SNORM`
`static final int`
`GL_RGBA16_SNORM`
`static final int`
`GL_RGBA8_SNORM`
`static final int`
`GL_SAMPLER_2D_RECT`
Returned by <type> parameter of GetActiveUniform when the location <index> for program object <program> is of type sampler2DRect:
`static final int`
`GL_SAMPLER_2D_RECT_SHADOW`
Returned by <type> parameter of GetActiveUniform when the location <index> for program object <program> is of type sampler2DRectShadow:
`static final int`
`GL_SIGNED_NORMALIZED`
`static final int`
`GL_TEXTURE_BINDING_BUFFER`
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:
`static final int`
`GL_TEXTURE_BINDING_RECTANGLE`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv and GetDoublev:
`static final int`
`GL_TEXTURE_BUFFER`
Accepted by the <target> parameter of BindBuffer, BufferData, BufferSubData, MapBuffer, MapBufferRange, BindTexture, UnmapBuffer, GetBufferSubData, GetBufferParameteriv, GetBufferPointerv, and TexBuffer, and the <pname> parameter of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:
`static final int`
`GL_TEXTURE_BUFFER_DATA_STORE_BINDING`
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:
`static final int`
`GL_TEXTURE_BUFFER_FORMAT`
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:
`static final int`
`GL_TEXTURE_RECTANGLE`
Accepted by the <cap> parameter of Enable, Disable and IsEnabled; by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv and GetDoublev; and by the <target> parameter of BindTexture, GetTexParameterfv, GetTexParameteriv, TexParameterf, TexParameteri, TexParameterfv and TexParameteriv: Accepted by the <target> parameter of GetTexImage, GetTexLevelParameteriv, GetTexLevelParameterfv, TexImage2D, CopyTexImage2D, TexSubImage2D and CopySubTexImage2D:
`static final int`
`GL_UNIFORM_ARRAY_STRIDE`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_BINDING`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_DATA_SIZE`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_INDEX`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_BLOCK_NAME_LENGTH`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER`
Accepted by the <pname> parameter of GetActiveUniformBlockiv:
`static final int`
`GL_UNIFORM_BUFFER`
Accepted by the <target> parameters of BindBuffer, BufferData, BufferSubData, MapBuffer, UnmapBuffer, GetBufferSubData, and GetBufferPointerv:
`static final int`
`GL_UNIFORM_BUFFER_BINDING`
Accepted by the <pname> parameter of GetIntegeri_v, GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT`
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:
`static final int`
`GL_UNIFORM_BUFFER_SIZE`
Accepted by the <pname> parameter of GetIntegeri_v:
`static final int`
`GL_UNIFORM_BUFFER_START`
Accepted by the <pname> parameter of GetIntegeri_v:
`static final int`
`GL_UNIFORM_IS_ROW_MAJOR`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_MATRIX_STRIDE`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_NAME_LENGTH`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_OFFSET`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_SIZE`
Accepted by the <pname> parameter of GetActiveUniformsiv:
`static final int`
`GL_UNIFORM_TYPE`
Accepted by the <pname> parameter of GetActiveUniformsiv:

## Method Summary

Modifier and Type
Method
Description
`static void`
`glCopyBufferSubData(int readtarget, int writetarget, long readoffset, long writeoffset, long size)`
`static void`
`glDrawArraysInstanced(int mode, int first, int count, int primcount)`
`static void`
`glDrawElementsInstanced(int mode, int indices_count, int type, long indices_buffer_offset, int primcount)`
`static void`
`glDrawElementsInstanced(int mode, ByteBuffer indices, int primcount)`
`static void`
`glDrawElementsInstanced(int mode, IntBuffer indices, int primcount)`
`static void`
`glDrawElementsInstanced(int mode, ShortBuffer indices, int primcount)`
`static int`
`glGetActiveUniformBlock(int program, int uniformBlockIndex, int pname)`
Deprecated.
Will be removed in 3.0.
`static void`
`glGetActiveUniformBlock(int program, int uniformBlockIndex, int pname, IntBuffer params)`
`static int`
`glGetActiveUniformBlocki(int program, int uniformBlockIndex, int pname)`
Overloads glGetActiveUniformBlockiv.
`static String`
`glGetActiveUniformBlockName(int program, int uniformBlockIndex, int bufSize)`
Overloads glGetActiveUniformBlockName.
`static void`
`glGetActiveUniformBlockName(int program, int uniformBlockIndex, IntBuffer length, ByteBuffer uniformBlockName)`
`static String`
`glGetActiveUniformName(int program, int uniformIndex, int bufSize)`
Overloads glGetActiveUniformName.
`static void`
`glGetActiveUniformName(int program, int uniformIndex, IntBuffer length, ByteBuffer uniformName)`
`static int`
`glGetActiveUniforms(int program, int uniformIndex, int pname)`
Deprecated.
Will be removed in 3.0.
`static void`
`glGetActiveUniforms(int program, IntBuffer uniformIndices, int pname, IntBuffer params)`
`static int`
`glGetActiveUniformsi(int program, int uniformIndex, int pname)`
Overloads glGetActiveUniformsiv.
`static int`
`glGetUniformBlockIndex(int program, CharSequence uniformBlockName)`
Overloads glGetUniformBlockIndex.
`static int`
`glGetUniformBlockIndex(int program, ByteBuffer uniformBlockName)`
`static void`
`glGetUniformIndices(int program, CharSequence[] uniformNames, IntBuffer uniformIndices)`
Overloads glGetUniformIndices.
`static void`
`glGetUniformIndices(int program, ByteBuffer uniformNames, IntBuffer uniformIndices)`
`static void`
`glPrimitiveRestartIndex(int index)`
`static void`
`glTexBuffer(int target, int internalformat, int buffer)`
`static void`
`glUniformBlockBinding(int program, int uniformBlockIndex, int uniformBlockBinding)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### GL_RED_SNORM

public static final int GL_RED_SNORM

See Also:
  - Constant Field Values

### GL_RG_SNORM

public static final int GL_RG_SNORM

See Also:
  - Constant Field Values

### GL_RGB_SNORM

public static final int GL_RGB_SNORM

See Also:
  - Constant Field Values

### GL_RGBA_SNORM

public static final int GL_RGBA_SNORM

See Also:
  - Constant Field Values

### GL_R8_SNORM

public static final int GL_R8_SNORM

See Also:
  - Constant Field Values

### GL_RG8_SNORM

public static final int GL_RG8_SNORM

See Also:
  - Constant Field Values

### GL_RGB8_SNORM

public static final int GL_RGB8_SNORM

See Also:
  - Constant Field Values

### GL_RGBA8_SNORM

public static final int GL_RGBA8_SNORM

See Also:
  - Constant Field Values

### GL_R16_SNORM

public static final int GL_R16_SNORM

See Also:
  - Constant Field Values

### GL_RG16_SNORM

public static final int GL_RG16_SNORM

See Also:
  - Constant Field Values

### GL_RGB16_SNORM

public static final int GL_RGB16_SNORM

See Also:
  - Constant Field Values

### GL_RGBA16_SNORM

public static final int GL_RGBA16_SNORM

See Also:
  - Constant Field Values

### GL_SIGNED_NORMALIZED

public static final int GL_SIGNED_NORMALIZED

See Also:
  - Constant Field Values

### GL_COPY_READ_BUFFER_BINDING

public static final int GL_COPY_READ_BUFFER_BINDING

See Also:
  - Constant Field Values

### GL_COPY_WRITE_BUFFER_BINDING

public static final int GL_COPY_WRITE_BUFFER_BINDING

See Also:
  - Constant Field Values

### GL_COPY_READ_BUFFER

public static final int GL_COPY_READ_BUFFER

See Also:
  - Constant Field Values

### GL_COPY_WRITE_BUFFER

public static final int GL_COPY_WRITE_BUFFER

See Also:
  - Constant Field Values

### GL_PRIMITIVE_RESTART

public static final int GL_PRIMITIVE_RESTART
Accepted by the <cap> parameter of IsEnabled, and by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_PRIMITIVE_RESTART_INDEX

public static final int GL_PRIMITIVE_RESTART_INDEX
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_TEXTURE_BUFFER

public static final int GL_TEXTURE_BUFFER
Accepted by the <target> parameter of BindBuffer, BufferData, BufferSubData, MapBuffer, MapBufferRange, BindTexture, UnmapBuffer, GetBufferSubData, GetBufferParameteriv, GetBufferPointerv, and TexBuffer, and the <pname> parameter of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:

See Also:
  - Constant Field Values

### GL_MAX_TEXTURE_BUFFER_SIZE

public static final int GL_MAX_TEXTURE_BUFFER_SIZE
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:

See Also:
  - Constant Field Values

### GL_TEXTURE_BINDING_BUFFER

public static final int GL_TEXTURE_BINDING_BUFFER
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:

See Also:
  - Constant Field Values

### GL_TEXTURE_BUFFER_DATA_STORE_BINDING

public static final int GL_TEXTURE_BUFFER_DATA_STORE_BINDING
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:

See Also:
  - Constant Field Values

### GL_TEXTURE_BUFFER_FORMAT

public static final int GL_TEXTURE_BUFFER_FORMAT
Accepted by the <pname> parameters of GetBooleanv, GetDoublev, GetFloatv, and GetIntegerv:

See Also:
  - Constant Field Values

### GL_TEXTURE_RECTANGLE

public static final int GL_TEXTURE_RECTANGLE
Accepted by the <cap> parameter of Enable, Disable and IsEnabled; by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv and GetDoublev; and by the <target> parameter of BindTexture, GetTexParameterfv, GetTexParameteriv, TexParameterf, TexParameteri, TexParameterfv and TexParameteriv: Accepted by the <target> parameter of GetTexImage, GetTexLevelParameteriv, GetTexLevelParameterfv, TexImage2D, CopyTexImage2D, TexSubImage2D and CopySubTexImage2D:

See Also:
  - Constant Field Values

### GL_TEXTURE_BINDING_RECTANGLE

public static final int GL_TEXTURE_BINDING_RECTANGLE
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv and GetDoublev:

See Also:
  - Constant Field Values

### GL_PROXY_TEXTURE_RECTANGLE

public static final int GL_PROXY_TEXTURE_RECTANGLE
Accepted by the <target> parameter of GetTexLevelParameteriv, GetTexLevelParameterfv, GetTexParameteriv and TexImage2D:

See Also:
  - Constant Field Values

### GL_MAX_RECTANGLE_TEXTURE_SIZE

public static final int GL_MAX_RECTANGLE_TEXTURE_SIZE
Accepted by the <pname> parameter of GetBooleanv, GetDoublev, GetIntegerv and GetFloatv:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_RECT

public static final int GL_SAMPLER_2D_RECT
Returned by <type> parameter of GetActiveUniform when the location <index> for program object <program> is of type sampler2DRect:

See Also:
  - Constant Field Values

### GL_SAMPLER_2D_RECT_SHADOW

public static final int GL_SAMPLER_2D_RECT_SHADOW
Returned by <type> parameter of GetActiveUniform when the location <index> for program object <program> is of type sampler2DRectShadow:

See Also:
  - Constant Field Values

### GL_UNIFORM_BUFFER

public static final int GL_UNIFORM_BUFFER
Accepted by the <target> parameters of BindBuffer, BufferData, BufferSubData, MapBuffer, UnmapBuffer, GetBufferSubData, and GetBufferPointerv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BUFFER_BINDING

public static final int GL_UNIFORM_BUFFER_BINDING
Accepted by the <pname> parameter of GetIntegeri_v, GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_UNIFORM_BUFFER_START

public static final int GL_UNIFORM_BUFFER_START
Accepted by the <pname> parameter of GetIntegeri_v:

See Also:
  - Constant Field Values

### GL_UNIFORM_BUFFER_SIZE

public static final int GL_UNIFORM_BUFFER_SIZE
Accepted by the <pname> parameter of GetIntegeri_v:

See Also:
  - Constant Field Values

### GL_MAX_VERTEX_UNIFORM_BLOCKS

public static final int GL_MAX_VERTEX_UNIFORM_BLOCKS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_GEOMETRY_UNIFORM_BLOCKS

public static final int GL_MAX_GEOMETRY_UNIFORM_BLOCKS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_FRAGMENT_UNIFORM_BLOCKS

public static final int GL_MAX_FRAGMENT_UNIFORM_BLOCKS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_COMBINED_UNIFORM_BLOCKS

public static final int GL_MAX_COMBINED_UNIFORM_BLOCKS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_UNIFORM_BUFFER_BINDINGS

public static final int GL_MAX_UNIFORM_BUFFER_BINDINGS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_UNIFORM_BLOCK_SIZE

public static final int GL_MAX_UNIFORM_BLOCK_SIZE
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS

public static final int GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS

public static final int GL_MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS

public static final int GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT

public static final int GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT
Accepted by the <pname> parameter of GetBooleanv, GetIntegerv, GetFloatv, and GetDoublev:

See Also:
  - Constant Field Values

### GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH

public static final int GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH
Accepted by the <pname> parameter of GetProgramiv:

See Also:
  - Constant Field Values

### GL_ACTIVE_UNIFORM_BLOCKS

public static final int GL_ACTIVE_UNIFORM_BLOCKS
Accepted by the <pname> parameter of GetProgramiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_TYPE

public static final int GL_UNIFORM_TYPE
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_SIZE

public static final int GL_UNIFORM_SIZE
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_NAME_LENGTH

public static final int GL_UNIFORM_NAME_LENGTH
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_INDEX

public static final int GL_UNIFORM_BLOCK_INDEX
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_OFFSET

public static final int GL_UNIFORM_OFFSET
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_ARRAY_STRIDE

public static final int GL_UNIFORM_ARRAY_STRIDE
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_MATRIX_STRIDE

public static final int GL_UNIFORM_MATRIX_STRIDE
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_IS_ROW_MAJOR

public static final int GL_UNIFORM_IS_ROW_MAJOR
Accepted by the <pname> parameter of GetActiveUniformsiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_BINDING

public static final int GL_UNIFORM_BLOCK_BINDING
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_DATA_SIZE

public static final int GL_UNIFORM_BLOCK_DATA_SIZE
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_NAME_LENGTH

public static final int GL_UNIFORM_BLOCK_NAME_LENGTH
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS

public static final int GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES

public static final int GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER

public static final int GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER

public static final int GL_UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER

public static final int GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER
Accepted by the <pname> parameter of GetActiveUniformBlockiv:

See Also:
  - Constant Field Values

### GL_INVALID_INDEX

public static final int GL_INVALID_INDEX
Returned by GetActiveUniformsiv and GetUniformBlockIndex

See Also:
  - Constant Field Values

## Method Details

### glDrawArraysInstanced

public static void glDrawArraysInstanced(int mode, int first, int count, int primcount)

### glDrawElementsInstanced

public static void glDrawElementsInstanced(int mode, ByteBuffer indices, int primcount)

### glDrawElementsInstanced

public static void glDrawElementsInstanced(int mode, IntBuffer indices, int primcount)

### glDrawElementsInstanced

public static void glDrawElementsInstanced(int mode, ShortBuffer indices, int primcount)

### glDrawElementsInstanced

public static void glDrawElementsInstanced(int mode, int indices_count, int type, long indices_buffer_offset, int primcount)

### glCopyBufferSubData

public static void glCopyBufferSubData(int readtarget, int writetarget, long readoffset, long writeoffset, long size)

### glPrimitiveRestartIndex

public static void glPrimitiveRestartIndex(int index)

### glTexBuffer

public static void glTexBuffer(int target, int internalformat, int buffer)

### glGetUniformIndices

public static void glGetUniformIndices(int program, ByteBuffer uniformNames, IntBuffer uniformIndices)

### glGetUniformIndices

public static void glGetUniformIndices(int program, CharSequence[] uniformNames, IntBuffer uniformIndices)
Overloads glGetUniformIndices.

### glGetActiveUniforms

public static void glGetActiveUniforms(int program, IntBuffer uniformIndices, int pname, IntBuffer params)

### glGetActiveUniforms

@Deprecated public static int glGetActiveUniforms(int program, int uniformIndex, int pname)
Deprecated.
Will be removed in 3.0. Use `glGetActiveUniformsi(int, int, int)` instead.
Overloads glGetActiveUniformsiv.

### glGetActiveUniformsi

public static int glGetActiveUniformsi(int program, int uniformIndex, int pname)
Overloads glGetActiveUniformsiv.

### glGetActiveUniformName

public static void glGetActiveUniformName(int program, int uniformIndex, IntBuffer length, ByteBuffer uniformName)

### glGetActiveUniformName

public static String glGetActiveUniformName(int program, int uniformIndex, int bufSize)
Overloads glGetActiveUniformName.

### glGetUniformBlockIndex

public static int glGetUniformBlockIndex(int program, ByteBuffer uniformBlockName)

### glGetUniformBlockIndex

public static int glGetUniformBlockIndex(int program, CharSequence uniformBlockName)
Overloads glGetUniformBlockIndex.

### glGetActiveUniformBlock

public static void glGetActiveUniformBlock(int program, int uniformBlockIndex, int pname, IntBuffer params)

### glGetActiveUniformBlock

@Deprecated public static int glGetActiveUniformBlock(int program, int uniformBlockIndex, int pname)
Deprecated.
Will be removed in 3.0. Use `glGetActiveUniformBlocki(int, int, int)` instead.
Overloads glGetActiveUniformBlockiv.

### glGetActiveUniformBlocki

public static int glGetActiveUniformBlocki(int program, int uniformBlockIndex, int pname)
Overloads glGetActiveUniformBlockiv.

### glGetActiveUniformBlockName

public static void glGetActiveUniformBlockName(int program, int uniformBlockIndex, IntBuffer length, ByteBuffer uniformBlockName)

### glGetActiveUniformBlockName

public static String glGetActiveUniformBlockName(int program, int uniformBlockIndex, int bufSize)
Overloads glGetActiveUniformBlockName.

### glUniformBlockBinding

public static void glUniformBlockBinding(int program, int uniformBlockIndex, int uniformBlockBinding)